// Bookia Lib 0.1 (c)2013 Pablo Martin - WeSapiens
var bookiaLib = function()
{
    var eventMatchers = {
        'HTMLEvents': /^(?:load|unload|abort|error|select|change|submit|reset|focus|blur|resize|scroll)$/,
        'MouseEvents': /^(?:click|dblclick|mouse(?:down|up|over|move|out))$/
    }
    var defaultOptions = {
        pointerX: 0,
        pointerY: 0,
        button: 0,
        ctrlKey: false,
        altKey: false,
        shiftKey: false,
        metaKey: false,
        bubbles: true,
        cancelable: true
    }

    function _init()
    {
        _initTouch();
    }

    function _initTouch()
    {
        //if ('touchstart' in window)
        //{
          document.addEventListener('touchstart', function(event)
          {
            if(event.touches.length > 1)
                StageWebViewBridge.call('onGestureStart', null, 
                    event.touches[0].pageX,
                    event.touches[0].pageY,
                    event.touches[1].pageX,
                    event.touches[1].pageY);
          }, true);
        //}
    }

    function _onMouseCommunication(x, y)
    {
        //alert("looloolol " + x + "  " + y);
        //simulate(document.getElementById("interactive_image"), "mousedown", {pointerX: x, pointerY: y});
        //simulate(document.getElementById("interactive_image"), "mouseup", {pointerX: x, pointerY: y});
        elementMouseIsOver = document.elementFromPoint(x, y);
        if(elementMouseIsOver)
        {
            _simulate(elementMouseIsOver, "mousedown", {pointerX: x, pointerY: y});
            _simulate(elementMouseIsOver, "mouseup", {pointerX: x, pointerY: y});
            _simulate(elementMouseIsOver, "click", {pointerX: x, pointerY: y});
        }
    }

    function _simulate(element, eventName)
    {
        var options = _extend(defaultOptions, arguments[2] || {});
        var oEvent, eventType = null;

        for (var name in eventMatchers)
        {
            if (eventMatchers[name].test(eventName)) { eventType = name; break; }
        }

        if (!eventType)
            throw new SyntaxError('Only HTMLEvents and MouseEvents interfaces are supported');

        if (document.createEvent)
        {
            oEvent = document.createEvent(eventType);
            if (eventType == 'HTMLEvents')
            {
                oEvent.initEvent(eventName, options.bubbles, options.cancelable);
            }
            else
            {
                oEvent.initMouseEvent(eventName, options.bubbles, options.cancelable, document.defaultView,
                options.button, options.pointerX, options.pointerY, options.pointerX, options.pointerY,
                options.ctrlKey, options.altKey, options.shiftKey, options.metaKey, options.button, element);
            }
            element.dispatchEvent(oEvent);
        }
        else
        {
            options.clientX = options.pointerX;
            options.clientY = options.pointerY;
            var evt = document.createEventObject();
            oEvent = _extend(evt, options);
            element.fireEvent('on' + eventName, oEvent);
        }
        return element;
    }

    function _extend(destination, source) {
        for (var property in source)
          destination[property] = source[property];
        return destination;
    }

    var _variableExist = function(name){ return typeof this[name] !== 'undefined' };
    
    return {
        //Public API
        
        init : _init,
        
        onMouseCommunication: _onMouseCommunication
    };
}();


window.addEventListener("load", bookiaLib.init, false);